var prayerData;
var gFileSystemObject;
var gAdodbStream;
var gShellObject;
var prayerNames = new Array("Subuh", "Syuruk", "Zohor", "Asar", "Maghrib", "Isyak");
var monthNames = new Array("Muharram", "Safar", "Rabiulawal", "Rabiulakhir", "Jamadilawal", "Jamadilakhir", "Rejab", "Syaaban", "Ramadhan", "Syawal", "Zulkaedah", "Zulhijjah");
var isLoading = true;
var nextPrayerName = "";
var logging = false;
var focusBefore;
var mptServer = "https://mpt.i906.my/mpt.json";
var mptURL = mptServer + "";
var persistantSettings;
var soundpath;
var soundname;
var soundpath2;
var soundname2;
var soundpath3;
var soundname3;
var retry = 0;
var notificationTime;
var alarmTime;

function needUpdate(version) {
    return countPoints(version) > countPoints(System.Gadget.version);
}

function countPoints(data) {
    data = data.split(".");
    return 1000 * parseInt(data[0]) + 100 * parseInt(data[1]) + 10 * parseInt(data[2]) + 1 * parseInt(data[3]);
}

function init() {
    logger("init");
    System.Gadget.onUndock = checkState;
    System.Gadget.onDock = checkState;
    System.Gadget.settingsUI = "settings.html";
    System.Gadget.onSettingsClosed = restartMPT;
    System.Gadget.onSettingsClosing = saveSettings;
    
    gShellObject = new ActiveXObject("Wscript.Shell");
    gFileSystemObject = new ActiveXObject("Scripting.FileSystemObject");

    var savedSettings = readSettings('myloc', '');
    focusBefore = readSettings('focusBefore', '15');

    if (savedSettings == "") {
       welcome();
       return;
    }

    $.ajaxSetup({
        cache: false,
        data: {
            "code": savedSettings
        },
        dataType: "json",
        timeout: 25000,
        url: mptURL
    });
 
    spinner = new getSpinner("loader");

    startMPT();
}

function restartMPT(e) {
    logger("restartMPT");

    if (e.closeAction == e.Action.commit) {

        var savedSettings = readSettings('myloc', '');
        focusBefore = readSettings('focusBefore', '15');

        $.ajaxSetup({
            cache: false,
            data: {
                "code": savedSettings
            },
            dataType: "json",
            timeout: 25000,
            url: mptURL
        });

        startMPT();
    }
}

function startMPT() {
    logger("startMPT");
    $("#mintime").fadeOut("slow");
    $("#fulltime").fadeOut("slow");
    $("#errormsg").fadeOut("slow"); 
    $("#welcomemsg").fadeOut("slow"); 

    tr1 = $(document).stopTime();

    spinner = new getSpinner("loader");
    spinner.start();
    spinner.show();

    $.ajax({
        error: startMPT_e, 
        success: startMPT_r
    });
}

function welcome() {
    $("#welcomemsg").fadeIn("slow");  
}

function startMPT_e(xhr, textStatus, e) {
    logger("startMPT_e");
    spinner.stop();
    spinner.hide();

    var dataTime = readSettings('dataTime', '');
    var cachefile = System.Gadget.path + '\\cache.json';

    if (dataTime != "" && gFileSystemObject.FileExists(cachefile)) {
        cache = eval('(' + readFile(cachefile) + ')');

        if (cache.meta.errorType != "ERROR_INVALID_DATA") {
            startMPT_r(cache, "cache");
            return;
        }
    }

    logger("  error: " + textStatus);
    logger("  xhrerror: " + e);    

    if (textStatus == "error") {
        $("#themsg").text("Unable to connect to the internet.");
    } else if (textStatus == "timeout"){
        $("#themsg").text("Connection timed out.");
    } else if (textStatus == "esolaterror"){
        $("#themsg").text("JAKIM E-Solat offline.");
    } else {
        $("#themsg").text(textStatus);
    }

    $("#mintime").fadeOut("slow");
    $("#fulltime").fadeOut("slow");
    $("#errormsg").fadeIn("slow");    
    $(document).everyTime(60 * ++retry + "s", "autoRestartMPT", startMPT);
    logger("  retrying in " + 60 * retry + " seconds");   
}

function startMPT_r(data, textStatus, jqXHR) {
    logger("startMPT_r");
    spinner.stop();
    spinner.hide();
    isLoading = false;
    esolaterror = false;
    ftr = readSettings("footer", "lt");

    if (esolaterror) {
        startMPT_e(null, "esolaterror");
        return;
    }

    logger("  textStatus: " + textStatus);

    if (textStatus == "success" || textStatus == "cache") {

        var dataTime = new Date();

        if (textStatus != "cache" && !esolaterror) {
            var values = [];

            logger("  writing to cache");

            values['dataTime'] = dataTime.getTime();
            writeSettings(values);
            writeToFile(System.Gadget.path + '\\cache.json', jqXHR.responseText);
        }

        prayerData = data.response.times[dataTime.getDate() - 1]; 
        
        updateCountdown();
        updatePrayerTimes();
        updateNextAlarm();
        updateNextNotification();
        
        $(document).everyTime("1s", "updateCountdown", updateCountdown);
        $(document).everyTime("18000s", "refreshGadget", startMPT);

        if (!System.Gadget.docked) {
            undockedState();
            fulltime.style.display = "none";
            $("#mintime").fadeIn("slow");
            $("#fulltime").fadeIn("slow");
        } else if (System.Gadget.docked) {
            dockedState();
            $("#mintime").fadeIn("slow");
        }    

        if (ftr == "id") {
            $("#placename").html(getIslamicDate());
        } else {
            $("#placename").html(data.response.place);        
        }
    }
}

function createReadableTime(d) {
    var h = d.getHours();
    var m = d.getMinutes();
    return (h < 10 ? "0" + h : h) + ":" + (m < 10 ? "0" + m : m);
}

function updatePrayerTimes() {
    var pt;

    for (i = 0; i < prayerData.length; i++) {
        pt = new Date(prayerData[i] * 1000);
        $("#pt" + i).html(createReadableTime(pt));
    }
}

function highlightPrayer(c) {
    for (i = 0; i < 6; i++) {
        $("#pn" + i).removeClass("highlight");
        $("#pt" + i).removeClass("highlight");
    }

    $("#pn" + c).addClass("highlight");
    $("#pt" + c).addClass("highlight");
}

function checkCurrentPrayer() {
    logger('checkCurrentPrayer');

    var now = new Date();
    var data = prayerData;
    var pos = 0;

    for (var i = 0; i < data.length; i++) {
        var currentTime = new Date(data[i] * 1000);

        if (currentTime > now) {
          break;
        }

        pos++;
    }
    
    prayerIndex = (pos - 1 == -1) ? 5 : pos - 1;

    logger('  prayer ' + prayerIndex);
    return prayerIndex;
}

function checkState() {
    if (!System.Gadget.docked) {
        undockedState();
    } else if (System.Gadget.docked) {
        dockedState();
    }
}

function dockedState() {

    cdns = readSettings('cdn', '1');

    document.body.style.width = 140;
    document.body.style.height = 93;

    mptbg.style.width = 140;
    mptbg.style.height = 93;
    mptbg.src = "url(images/bg1.png)";

    if (!isLoading) {
        prayer.style.display = "block";
        fulltime.style.display = "none";
        place.style.display = "none";
        timer.style.marginTop = 6;
    }

    notify.style.top = 16;
    loader.style.top = 53;
    errormsg.style.marginTop = 9;
    welcomemsg.style.marginTop = 9;

    if (cdns == '0') {
        timer.style.display = "none";
        titles.style.display = "none";
        thetime.style.display = "block";
    } else {
        timer.style.display = "block";
        titles.style.display = "block";
        thetime.style.display = "none";
    }
}

function undockedState() {

    cdns = readSettings('cdn', '1');

    document.body.style.width = 140;
    document.body.style.height = 204;

    mptbg.style.width = 139;
    mptbg.style.height = 204;
    mptbg.src = "url(images/bg2.png)";

    if (!isLoading) {
        prayer.style.display = "none";
        fulltime.style.display = "block";
        place.style.display = "block";
        timer.style.marginTop = 14;
    }

    notify.style.top = 170;
    loader.style.top = 100;
    errormsg.style.marginTop = 15;
    welcomemsg.style.marginTop = 15;

    //if (cdns == '0') {
    //    timer.style.display = "none";
    //    titles.style.display = "none";
    //    thetime.style.display = "block";
    //} else {
        timer.style.display = "block";
        titles.style.display = "block";
        thetime.style.display = "none";
    //}
}

function getSecondsLeft(time) {
    var dateStart = new Date();
    var dateEnd = new Date(time);
    return (dateEnd - dateStart);
}

function updateCountdown() {
    logger('updateCountdown');
    var currentPrayer = checkCurrentPrayer();
    var nextPrayerTime = prayerData[(currentPrayer + 1) % 6];
    var duration = getSecondsLeft(nextPrayerTime * 1000);
    var now = new Date();
    var ftr = readSettings("footer", "lt");

    highlightPrayer(currentPrayer);

    do {
        if (duration <= 0) {
            duration += 86400 * 1000;
        }
    } while (duration <= 0);

    duration /= 1000;
    var hours = Math.floor((duration % 86400) / 3600);
    var minutes = Math.floor(((duration % 86400) - (hours * 3600)) / 60);
    var seconds = Math.floor((duration % 86400) - (hours * 3600) - (minutes * 60));

    $("#c1").html(hours < 10 ? "0" + hours : hours);
    $("#c2").html(minutes < 10 ? "0" + minutes : minutes);
    $("#c3").html(seconds < 10 ? "0" + seconds : seconds);

    $("#prayer").html(prayerNames[(currentPrayer + 1) % 6]);
    $("#ttpt").html(createReadableTime(new Date(nextPrayerTime * 1000)));

    if (ftr == "id") {
        $("#placename").html(getIslamicDate());
    }
}

function settingsInit() {

    System.Gadget.onSettingsClosing = saveSettings;

    var savedSettings = readSettings('myloc', 'wlp-0');
    var dataTime = readSettings('dataTime', '');
    focusBefore = readSettings('focusBefore', '15');
    soundname = readSettings('soundname', '');
    soundname2 = readSettings('soundname2', '');
    soundname3 = readSettings('soundname3', '');
    soundpath = readSettings('soundpath', '');
    soundpath2 = readSettings('soundpath2', '');
    soundpath3 = readSettings('soundpath3', '');
    offset = readSettings('offset', '-1');
    footer = readSettings('footer', 'lt');
    cdns = readSettings('cdn', '1');

    az1 = readSettings('az1', 0);
    az2 = readSettings('az2', 0);
    az3 = readSettings('az3', 0);
    az4 = readSettings('az4', 0);
    az5 = readSettings('az5', 0);
    az6 = readSettings('az6', 0);

    $.ajax({
        cache: false,
        data: {
            "q": "updates"
        },
        dataType: "json",
        success: function(data) {
            if (needUpdate(data.widgetVersion)) {
                $("#updates").fadeIn("slow");
                $("#notifylink").attr("href", mptServer);
            }
        },
        url: mptServer        
    });
    
    $("#fgt").val(focusBefore);

    for (i = 0; i < statenames.length; i++) {
        op1 = $("<option>", {
            "value": statenames[i].code, 
            text: statenames[i].name
        });
        $(op1).appendTo("#mystate");       

        savedState = savedSettings.split("-")[0];

        if (savedState == statenames[i].code) {
            $("#mystate").val(savedState);
            populateStateDetails(savedState);
            $("#myloc").val(savedSettings);
        }
    }

    $("#mystate").change(function(evt) {
        populateStateDetails($(this).val());
    });

    $("#alm").change(function(evt) {
        if ($(this).val() == "0") {
            $("#mediaset").attr("disabled", "disabled");
            $("#mediaset2").attr("disabled", "disabled");
        } else {
            $("#mediaset").attr("disabled", null); 
            $("#mediaset2").attr("disabled", null);
        }
    });

    $("#ftr").change(function(evt) {
        if ($(this).val() != "id") {
            $("#offsetset").attr("disabled", "disabled");
        } else {
            $("#offsetset").attr("disabled", null); 
        }
    });

    $("#dtr").val(offset);
    $("#ftr").val(footer);
    $("#cdn").val(cdns);

    for (i = 1; i <= 6; i++) {
        $("#alarm" + i).val(this["az" + i]);
    }

    if (footer == "id") {
        $("#offsetset").attr("disabled", null); 
    }

    if (dataTime != "") {
        dt = new Date(parseInt(dataTime));
        dtt = dt.getDate() + "/" + (dt.getMonth() + 1) + " " + createReadableTime(dt);
    } else {
        dtt = "None";
    }

    if (soundname != "") {
        $("#medialoc").html(soundname);
    }

    if (soundname2 != "") {
        $("#medialoc2").html(soundname2);
    }

    if (soundname3 != "") {
        $("#medialoc3").html(soundname3);
    }

    $("#lastupdate").html(dtt);
    $("#ver").html("Version " + System.Gadget.version);
    $("#verlink").attr("href", System.Gadget.path + "\\changelog.txt");

    showTab(1);
}

function saveSettings(e) {
    if (e.closeAction == e.Action.commit) {

        var settings = [];
        settings['myloc'] = $("#myloc").val();
        settings['focusBefore'] = $("#fgt").val();
        settings['footer'] = $("#ftr").val();
        settings['soundpath'] = soundpath;
        settings['soundname'] = soundname;
        settings['soundpath2'] = soundpath2;
        settings['soundname2'] = soundname2;
        settings['soundpath3'] = soundpath3;
        settings['soundname3'] = soundname3;
        settings['offset'] = $("#dtr").val();
        settings['cdn'] = $("#cdn").val();

        for (i = 1; i <= 6; i++) {
            settings['az' + i] = $("#alarm" + i).val();
        }

        writeSettings(settings);
        writeINI(settings);

    }
}

function chooseSound(id) {
    var s = System.Shell.chooseFile(true, "Audio file (*.mp3; *.wav; *.wma)", "", "*.mp3;*.wav;*.wma;");
    if (s != null) {
        $(id).html(s.name);

        if (id == '#medialoc') {
            soundpath = s.path;
            soundname = s.name;    
        } else if (id == '#medialoc2') {
            soundpath2 = s.path;
            soundname2 = s.name;    
        } else if (id == '#medialoc3') {
            soundpath3 = s.path;
            soundname3 = s.name;    
        }
        
    }
}

function populateStateDetails(data) {
    $("#myloc").empty();

    for (j = 0; j < statedetails[data].length; j++) {
        op2 = $("<option>", {
            "value": data + "-" + j, 
            text: statedetails[data][j]
        });
        $(op2).appendTo("#myloc");       
    }
}

function logger(msg) {

    if (!logging) return;

    var path = System.Gadget.path + '\\log.txt';
    var old = "";

    if (gFileSystemObject == null) {
        gFileSystemObject = new ActiveXObject("Scripting.FileSystemObject");
    }

    if (gFileSystemObject.FileExists(path)) {
        old = readFile(path);
    }

    var newLog = old + "[" + niceTime(new Date()) + "] " + msg + "\r\n";
    writeToFile(path, newLog);
}

function niceTime(d) {
    var h = d.getHours();
    var m = d.getMinutes();
    var s = d.getSeconds();
    return (h < 10 ? "0" + h : h) + ":" + (m < 10 ? "0" + m : m) + ":" + (s < 10 ? "0" + s : s);
}

function readFile(path) {

    if (!gAdodbStream) {
        gAdodbStream = new ActiveXObject("ADODB.Stream");
    }

    gAdodbStream.Open();
    gAdodbStream.CharSet = "UTF-8";
    gAdodbStream.LoadFromFile(path);
    var contents = gAdodbStream.ReadText();
    gAdodbStream.Close();
    return contents;
}

function writeToFile(path, contents) {
    if (!gAdodbStream) {
        gAdodbStream = new ActiveXObject("ADODB.Stream");
    }

    gAdodbStream.Open();
    gAdodbStream.CharSet = "UTF-8";
    gAdodbStream.WriteText(contents);
    gAdodbStream.SaveToFile(path, 2);
    gAdodbStream.Close();
}

function updateNextNotification() {
    logger("updateNextNotification");
    var currentPrayer = checkCurrentPrayer(prayerData);
    var pos = 1;
    var daymod = 0;
    var delay = parseInt(focusBefore);
    var now = new Date();

    do {
        var nextPrayerPos = (currentPrayer + pos) % 6;
        var nextPrayerTime = prayerData[nextPrayerPos];
        nextPrayerName = prayerNames[nextPrayerPos];
        var nnotify = new Date((nextPrayerTime * 1000) - (delay * 60000) + (daymod * 1000));
        var duration = getSecondsLeft(nnotify);
        var dursec = Math.ceil(duration / 1000) + 1;

        pos++;

        if ((currentPrayer + pos) % 6 == 0) {
            daymod += 86400;
        }
    } while (dursec < 5);

    $(document).oneTime(dursec + "s", triggerNotification);

    notificationTime = new Date();
    notificationTime.setTime(notificationTime.getTime() + dursec * 1000);

    logger("  Corrected prayer dates (+" + daymod / 86400 + " days)");
    logger("  Next Notification (" + nextPrayerName + "): " + nnotify);

}

function updateNextAlarm() {
    logger("updateNextAlarm");
    var currentPrayer = checkCurrentPrayer();
    var pos = 1;
    var daymod = 0;
    var now = new Date();

    do {
        var curPrayerPos = (currentPrayer + 1) % 6;
        var curPrayerTime = prayerData[curPrayerPos];
        var curPrayerName = prayerNames[curPrayerPos];
        var nalarm = new Date((curPrayerTime * 1000) + (daymod * 1000));
        var gslalm = getSecondsLeft(nalarm);
        var almsec = Math.ceil(gslalm / 1000) + 1;

        pos++;

        if ((currentPrayer + pos) % 6 == 0) {
            daymod += 86400;
        }
    } while (almsec < 5);

    $(document).oneTime(almsec + "s", triggerAlarm);

    alarmTime = new Date();
    alarmTime.setTime(alarmTime.getTime() + almsec * 1000);

    logger("  Corrected prayer dates (+" + daymod / 86400 + " days)");
    logger("  Next Alarm (" + curPrayerName + "): " + nalarm);
}

function getIslamicDate() {
    offset = parseInt(readSettings('offset', '0'));
    d = kuwaiticalendar(offset);
    return d[5] + " " + monthNames[d[6]] + " " + d[7];
}

function gadgetClick() {
   Player.Controls.stop();
}

function triggerAlarm() {
   logger("triggerAlarm");

   soundpath = readSettings('soundpath', '');
   soundpath2 = readSettings('soundpath2', '');
   soundpath3 = readSettings('soundpath3', '');
   currentPrayer = checkCurrentPrayer();
   alarmType = readSettings('az' + (currentPrayer + 1));
   Player.settings.volume = 100;

   logger("  alarmType: " + alarmType);

   if (alarmType != "0") {
       if (shouldTrigger(alarmTime)) {
            if (soundpath != "" && alarmType == "1") {
                Player.URL = soundpath;
                Player.Controls.play();
            }
            if (soundpath2 != "" && alarmType == "2") {
                Player.URL = soundpath2;
                Player.Controls.play();
            }
            if (soundpath3 != "" && alarmType == "3") {
                Player.URL = soundpath3;
                Player.Controls.play();
            }
            logger("  Triggered Alarm Type " + alarmType + " for " + currentPrayer);
       } else {
           logger("  suppressed alarm"); 
       }
   } else {
       logger("  alarm " + currentPrayer + " disabled")
   }

   updateNextAlarm();
}

function triggerNotification() {
    logger("triggerNotification");

    if (focusBefore != "0" && gFileSystemObject.FileExists(System.Gadget.path + '\\exec\\MPTNotify.exe')) {
        if (shouldTrigger(notificationTime)) {
            gShellObject.run('"' + System.Gadget.path + '\\exec\\MPTNotify.exe" "' + nextPrayerName + '" "' + focusBefore + '"');
            logger("  Triggered Notification (" + nextPrayerName + ")");
        } else {
            logger("  suppressed notification");
        }        

    }
 
    updateNextNotification();
}

function shouldTrigger(sup) {
    var now = new Date();

    logger("  shouldTrigger");
    logger("    now: " + now);
    logger("    sup: " + sup);
    logger("    dif:" + (now.getTime() - sup.getTime()) + " || " + (sup.getTime() - now.getTime()));

    if ((now.getTime() - sup.getTime()) < 60000 || (sup.getTime() - now.getTime()) > 60000) {
        return true;
    } else {
        return false;
    }
}

function readSettings(name, defValue) {
    var value = System.Gadget.Settings.readString(name);

    if (value)
        return value;

    if (!persistantSettings)
    	persistantSettings = readINI();

    value = persistantSettings[name];

    if (value != null && value != 'undefined') {
        System.Gadget.Settings.writeString(name, value);
	return value;
    }

    return defValue;

}

function writeSettings(values) {
	for (var key in values)
	    System.Gadget.Settings.writeString(key, values[key]);
}

function readINI() {
	var result = [];
        var path = System.Gadget.path + '\\..\\MPT.ini';
	if (!gFileSystemObject)
		gFileSystemObject = new ActiveXObject("Scripting.FileSystemObject");
		
  	if (!gFileSystemObject.FileExists(path))
  		return result;

	var lines = readFile(path).split(/\r?\n/);
	for (var i = 0; i < lines.length; i++)
	{
		if (lines[i].length > 0)
		{
		    var values = lines[i].split(/\s*=\s*/);
		    result[values.shift()] = values.join('=');
	    }
	}
	return result;
}

function writeINI(values) {
	var result = '';
        var path = System.Gadget.path + '\\..\\MPT.ini';
	for (var key in values)
	    result += key + '=' + values[key] + '\r\n';
	writeToFile(path, result);
}

function showTab(id) {
    for (i = 1; i <= 4; i++) {
        $("#tab" + i).hide();
    }
    $("#tab" + id).show();
}